package cd.casic.ci.process.engine.runContext;

import cd.casic.ci.process.process.dataObject.base.PipBaseElement;
import cd.casic.framework.commons.exception.ServiceException;
import cd.casic.framework.commons.exception.enums.GlobalErrorCodeConstants;

import java.time.LocalDateTime;
import java.util.Map;

public class StageRunContext extends BaseRunContext{
    public StageRunContext(PipBaseElement contextDef, BaseRunContext parentContext, LocalDateTime startTime, String resourceId, String targetId, String targetType, Map<String, Object> globalVariables, Map<String, Object> localVariables, Map<String, BaseRunContext> childContext) {
        super(contextDef, parentContext, startTime, resourceId, targetId, targetType, globalVariables, localVariables, childContext);
    }

    @Override
    public BaseRunContext getChildRunContext(String taskId) {
        Map<String, BaseRunContext> childContext = getChildContext();
        for (Map.Entry<String, BaseRunContext> entry : childContext.entrySet()) {
            BaseRunContext childRunContext = entry.getValue().getChildRunContext(taskId);
            if (childRunContext!=null) {
                return childRunContext;
            }
        }
        return null;
    }

    @Override
    public void putChildRunContext(String key, BaseRunContext context) {
        Map<String, BaseRunContext> childContext = getChildContext();
        if (context instanceof TaskRunContext) {
            childContext.put(key,context);
        } else {
            throw new ServiceException(GlobalErrorCodeConstants.PIPELINE_ERROR.getCode(),"不支持类型");
        }
    }
}
